Name:           tmt
Version:        1.35.dev888
Release:        1.20240729122845833306.pr3088.67.g7d425704%{?dist}
Summary:        Test Management Tool

License:        MIT
URL:            https://github.com/teemtee/tmt
Source0:        tmt-1.35.0.dev67+g7d425704.tar.gz

BuildArch:      noarch
BuildRequires:  python3-devel

Requires:       git-core rsync sshpass

%if 0%{?fedora} < 40
Obsoletes:      python3-tmt < %{version}-%{release}
Provides:       tmt-report-html == %{version}-%{release}
Obsoletes:      tmt-report-html < %{version}-%{release}
Provides:       tmt-report-junit == %{version}-%{release}
Obsoletes:      tmt-report-junit < %{version}-%{release}
Provides:       tmt-report-polarion == %{version}-%{release}
Obsoletes:      tmt-report-polarion < %{version}-%{release}
Provides:       tmt-report-reportportal == %{version}-%{release}
Obsoletes:      tmt-report-reportportal < %{version}-%{release}
%endif

Recommends:     bash-completion

%py_provides    python3-tmt

%global _metapackage_description %{expand:
This is a metapackage bringing in extra dependencies for tmt.
It contains no code, just makes sure the dependencies are installed.}

%description
The tmt Python module and command line tool implement the test
metadata specification (L1 and L2) and allows easy test execution.

%pyproject_extras_subpkg -n tmt export-polarion
%pyproject_extras_subpkg -n tmt report-junit
%pyproject_extras_subpkg -n tmt report-polarion

%package -n     tmt+test-convert
Summary:        Dependencies required for tmt test import and export
Provides:       tmt-test-convert == %{version}-%{release}
%if 0%{?fedora} < 40
Obsoletes:      tmt-test-convert < %{version}-%{release}
%endif
Requires:       tmt == %{version}-%{release}
Requires:       make
Requires:       python3-bugzilla
Requires:       python3-nitrate
Requires:       python3-html2text
Requires:       python3-markdown

%description -n tmt+test-convert %_metapackage_description

%package -n     tmt+provision-container
Summary:        Dependencies required for tmt container provisioner
Provides:       tmt-provision-container == %{version}-%{release}
%if 0%{?fedora} < 40
Obsoletes:      tmt-provision-container < %{version}-%{release}
%endif
Requires:       tmt == %{version}-%{release}
Requires:       podman
Requires:       (ansible or ansible-collection-containers-podman)

%description -n tmt+provision-container %_metapackage_description

%package -n     tmt+provision-virtual
Summary:        Dependencies required for tmt virtual machine provisioner
Provides:       tmt-provision-virtual == %{version}-%{release}
%if 0%{?fedora} < 40
Obsoletes:      tmt-provision-virtual < %{version}-%{release}
%endif
Requires:       tmt == %{version}-%{release}
Requires:       python3-testcloud >= 0.9.10
Requires:       libvirt-daemon-config-network
Requires:       openssh-clients
Requires:       (ansible or ansible-core)
# Recommend qemu system emulators for supported arches
Recommends:     qemu-kvm-core
%if 0%{?fedora}
Recommends:     qemu-system-aarch64-core
Recommends:     qemu-system-ppc-core
Recommends:     qemu-system-s390x-core
Recommends:     qemu-system-x86-core
%endif

%description -n tmt+provision-virtual %_metapackage_description

%package -n     tmt+provision-beaker
Summary:        Dependencies required for tmt beaker provisioner
Provides:       tmt-provision-beaker == %{version}-%{release}
%if 0%{?fedora} < 40
Obsoletes:      tmt-provision-beaker < %{version}-%{release}
%endif
Requires:       tmt == %{version}-%{release}
Requires:       python3-mrack-beaker

%description -n tmt+provision-beaker %_metapackage_description

# Replace with pyproject_extras_subpkg at some point
%package -n     tmt+all
Summary:        Extra dependencies for the Test Management Tool
Provides:       tmt-all == %{version}-%{release}
%if 0%{?fedora} < 40
Obsoletes:      tmt-all < %{version}-%{release}
%endif
Requires:       tmt+test-convert == %{version}-%{release}
Requires:       tmt+export-polarion == %{version}-%{release}
Requires:       tmt+provision-container == %{version}-%{release}
Requires:       tmt+provision-virtual == %{version}-%{release}
Requires:       tmt+provision-beaker == %{version}-%{release}
Requires:       tmt+report-junit == %{version}-%{release}
Requires:       tmt+report-polarion == %{version}-%{release}

%description -n tmt+all
All extra dependencies of the Test Management Tool. Install this
package to have all available plugins ready for testing.

%prep
%autosetup -p1 -n tmt-1.35.0.dev67+g7d425704

%generate_buildrequires
%pyproject_buildrequires

%build
export SETUPTOOLS_SCM_PRETEND_VERSION=%{version}
%pyproject_wheel

%install
%pyproject_install
%pyproject_save_files tmt

mkdir -p %{buildroot}%{_mandir}/man1
install -pm 644 tmt.1 %{buildroot}%{_mandir}/man1
mkdir -p %{buildroot}%{_datadir}/bash-completion/completions
install -pm 644 completions/bash/%{name} %{buildroot}%{_datadir}/bash-completion/completions/%{name}
mkdir -p %{buildroot}/etc/%{name}/
install -pm 644 %{name}/steps/provision/mrack/mrack* %{buildroot}/etc/%{name}/

%check
%pyproject_check_import

%files -n tmt -f %{pyproject_files}
%doc README.rst examples
%{_bindir}/tmt
%{_mandir}/man1/tmt.1.gz
%{_datadir}/bash-completion/completions/%{name}

%files -n tmt+provision-container -f %{_pyproject_ghost_distinfo}
%files -n tmt+provision-virtual -f %{_pyproject_ghost_distinfo}
%files -n tmt+test-convert -f %{_pyproject_ghost_distinfo}
%files -n tmt+provision-beaker -f %{_pyproject_ghost_distinfo}
%config(noreplace) %{_sysconfdir}/%{name}/mrack*
%files -n tmt+all -f %{_pyproject_ghost_distinfo}

%changelog
* Mon Jul 29 2024 Packit <hello@packit.dev> - 1.35.dev888-1.20240729122845833306.pr3088.67.g7d425704
- Dark theme by default (Martin Hoyer)
- Add favicon and logo to rtd (Martin Hoyer)
- Use sphinx builder to generate man page (Martin Hoyer)
- Switch to furo sphinx docs theme (Martin Hoyer)
- Avoid conflict between theme CSS and custom CSS files (Miloš Prchlík)
- Add `_compat` package (#3059) (Cristian Le)
- Support `tpm.version` hardware requirement for `mrack` (#3022) (skycastlelily)
- Fix loose ends in documentation after renaming plugin hrefs (#3115) (Miloš Prchlík)
- Change Polarion field which stores tmt id (#3080) (Petr Matyas)
- fix repating typo in user guide (#3111) (Mario Casquero)
- Fix links to plugins to start with `/` like other links (#3104) (Miloš Prchlík)
- Support `cpu.hyper-threading` hw requirement for `mrack` (#2953) (skycastlelily)
- Allow additional, local CSS file for documentation (#3026) (Miloš Prchlík)
- doc: minor grammatical update to README (#3099) (Link Dupont)
- Propagate result phase into report plugins (#3094) (Sabart Otto)
- Add HW requirement support matrix to docs (#3025) (Miloš Prchlík)
- Parse the `disk.sector-size`  hardware requirement (#2972) (skycastlelily)
- Coerce dimensionless values of SizeConstraint to values with dimensions (#3076) (skycastlelily)
- Save results before raising exception (#2996) (pholica)
- Make `mypy` happy about the `error.schema` content (Petr Šplíchal)
- The `--quiet` option shall silence warnings (#2909) (Miloš Prchlík)
- Add documention best practices, adjust release notes (#3007) (Miloš Prchlík)
- Fix collection of know keys for test, plan and story T001 linter (#3084) (Miloš Prchlík)
- Polish docs Makefile (Miloš Prchlík)
- Improve the initialization message (#3039) (Anatoli Babenia)
- Update HW requirement implementation links to match reality (#3066) (skycastlelily)
- Mention the `include-output-log` key in release notes (#3093) (Petr Šplíchal)
- Cleanup deprecated stuff from EPEL8 (#3060) (Cristian Le)
- Let the plugin `go()` method return a value (#2963) (Miloš Prchlík)
- Skip testing debuginfo install on coreos images (Petr Šplíchal)
- Add option to skip output log in junit and polarion reports (#3003) (Petr Matyas)
- Polish docs of the `avc` test check (#3029) (Miloš Prchlík)
- Mention hard reboot limited support in documentation (Miloš Prchlík)
- Switch to packit-handled rpm changelog and specfile cleanup (#2880) (Martin Hoyer)
- Pin the `Sphinx` version and update the docs theme (Martin Hoyer)
- Turn tmt/utils.py into a subpackage (#2982) (Miloš Prchlík)
- Fix handling of installation of packages from subdirectory (#3028) (Miloš Prchlík)
- Parse the `cpu.hyper-threading` hardware requirement (#2949) (skycastlelily)
- Update clean part of the example doc (#2883) (skycastlelily)
- Support `system.numanodes` hardware requirement for mrack (#2925) (skycastlelily)
- Fix normalization of regular expression lists (#3083) (Miloš Prchlík)
- Fix normalization of playbook/playbooks keys of ansible plugin (#3053) (Miloš Prchlík)
- Do not install epel-next-release on RHEL-8-like guests (#3081) (Miloš Prchlík)
- Allow `pre-commit` to run in subpath (#2007) (Cristian Le)
- Add descriptions to well-known process exit codes (#2955) (Miloš Prchlík)
- Add template helper for raising errors (#3009) (Miloš Prchlík)
- Support `location.lab-controller` hw requirement for `mrack` (#2927) (skycastlelily)
- Use vault.centos for centos-7 image repos (#3070) (Lukáš Zachar)
- Add a linter for Jinja2 templates (#3048) (Miloš Prchlík)
- Remove prepare/install fields leaking into prepare step data (#2986) (Miloš Prchlík)
- Add missing test case for parsing `device` HW requirement (#3012) (Miloš Prchlík)
- Add favicon to tmt docs (#3021) (Miloš Prchlík)
- Use ansible playbook from worktree (#2989) (Martin Klusoň)
- Add backwards compatibility for Logger.warn (Martin Hoyer)
- Removing shell=True from subprocess run (Martin Hoyer)
- Add ICN, TID, INT, Q ruff rules and clean-up (Martin Hoyer)
- Add flake8-pyi ruff rules (Martin Hoyer)
- Add flake8-logging and logging-format ruff rules (Martin Hoyer)
- Add flake8-implicit-str-concat ruff rules (Martin Hoyer)
- Add flake8-builtins ruff rules (Martin Hoyer)
- Add flake8-bandit ruff rules (Martin Hoyer)
- Add xfail for pip installation tests on py3.13 (#3043) (Martin Hoyer)
- Fix our custom Fedora CoreOS test image to avoid dnf/dnf5 conflicts (#3014) (Miloš Prchlík)
- Drop pint higher-bound (#2741) (Cristian Le)
- Add more tag separator options to polarion import (#3010) (Petr Matyas)
- Fix inaccuracy of `--failed-only` release note and docs (#3030) (Miloš Prchlík)
- Bump pre-commit checks (#3023) (Miloš Prchlík)
